//--------------------------------------------------------------------//
// 3D_W

var canvas;		// LoXvf
var x,y,width,height;	// `̈_ʒuCC
var context;	 	// ReLXg
var pressed;		// }EX{^
var mx,my;		// }EXʒu
var model;		// _Wf[^f
var mapView;		// ݂̕\
var currentEvent;	// Cxg̃CfbNX
var waitsw;		// bZ[Wҋ@
var depth;		// \s
var d3d;		// R}bv\[eBeB

// 
var DIR_TITLE=['  N','  E','  S','  W'];
var NORTH=0;		// k
var EAST=1;		// 
var SOUTH=2;		// 
var WEST=3;		// 

var VIEW_3D=0;		// 3D \
var VIEW_2D=1;		// 2D \

var NO_EVENT=-1;	// Cxg
var WALL=1;		// 
var DOOR=2;		// 

var NON_SELECT=0;	// CxgI𖳂
var SELECT_2WAY=1;	// 2
var MULTI_SELECT=2;	// I

var FONT_SIZE=16;		// tHgTCY
var BG_COLOR='#000000';		// wiF
var TEXT_COLOR='#000000';	// bZ[W\F
var BOARD_COLOR='#ffffff';	// bZ[W\wiF

// 3D_W
// fileName - f[^t@C
function initDungeon(fileName){
  model=new DungeonDataModel();
  mapView=VIEW_3D;
  currentEvent=NO_EVENT;
  waitsw=true;
  depth=6;
  document.getElementById('view').selectedIndex=mapView;
  initCanvas();
  readDungeonDataFile(fileName);
  draw();
}

// LoX
function initCanvas(){
  canvas=document.getElementById('dungeon');
  canvas.width=canvas.clientWidth;
  canvas.height=canvas.clientHeight;
  x=5;
  y=20;
  width=canvas.width-10;
  height=canvas.height-25;
  canvas.addEventListener('mousedown',mousePressed,false);
  canvas.addEventListener('mouseup',mouseReleased,false);
  document.addEventListener('keydown',keyPressed,false);
  context=canvas.getContext('2d');
  context.font=FONT_SIZE+"px 'Arial'";
  context.textBaseline='top';
  d3d=new Draw3D();
  pressed=false;
  mx=0;
  my=0;
}

// }EX{^̏s
function mousePressed(e){
  pressed=true;
  var rect=e.target.getBoundingClientRect();
  mx=e.clientX-rect.left;
  my=e.clientY-rect.top;
  var select=model.eventSelect(currentEvent,mx,my);
  switch(select){
    case 0:
      noAction();
      break;
    case 1:
      yesAction();
      break;
    default:
      elevatorAction(select-2);
      break;
  }
}

// }EX{^𗣂̏s
function mouseReleased(e){
  pressed=false;
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 38:		// (Numpad8 Off)
    case 56:		// 8
    case 104:		// Numpad8 On
      goAhead();
      break;
    case 37:		// (Numpad4 Off)
    case 52:		// 4
    case 100:		// Numpad4 On
      turnLeft();
      break;
    case 39:		// E(Numpad6 Off)
    case 54:		// 6
    case 102:		// Numpad6 On
      turnRight();
      break;
    case 40:		// (Numpad2 Off)
    case 50:		// 2
    case 98:		// Numpad2 On
      turnBack();
      break;
    case 12:		// (Numpad5 Off)
    case 53:		// 5
    case 67:		// C
    case 101:		// Numpad5 On
      changeView();
      break;
    case 35:		// End(Numpad1 Off)
    case 49:		// 1
    case 89:		// Y
    case 97:		// Numpad1 On
      yesAction();
      break;
    case 45:		// Ins(Numpad0 Off)
    case 48:		// 0
    case 78:		// N
    case 96:		// Numpad0 On
      noAction();
      break;
  }
}

// 3D_Wf[^t@Cǂݍ
// fileName - f[^t@C
function readDungeonDataFile(fileName){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      readDungeonData(xhr.responseText.split(/\r?\n/g));
    }
  };
  xhr.send(null);
}

// 3D_Wf[^ǂݍ
// s - f[^̃Xg
function readDungeonData(s){
  var row=0;
  row=readMapData(s,row);
  row=readEventData(s,row);
  row=readKeyData(s,row);
  currentEvent=model.getGrid(model.pp).event;
}

// }bvf[^ǂݍ
// s - f[^̃Xg
// row - s|C^
function readMapData(s,row){
  var ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
  model.floor.length=0;
  clearAss(model.floorIndex);
  model.title=ss[0];
  var floorCount=parseInt(ss[1]);
  row++;
  var j,k;
  for(var i=0;i<floorCount;i++){
    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    while(ss.length<2){
      row++;
      ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    }
    var label=parseInt(ss[1]);
    var title=getFloorTitle(label,ss[0]);
    row++;
    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    var n1=parseInt(ss[0]);
    var n2=parseInt(ss[1]);
    var grid=[];
    for(j=0;j<n1;j++){
      grid[j]=[];
      for(k=0;k<n2;k++){
      	grid[j][k]=new MapGrid(j,k);
      }
    }
    row++;
    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    var ceilColor='#'+ss[1];
    row++;
    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    var floorColor='#'+ss[1];
    row++;
    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    var wallColor='#'+ss[1];
    var swr=parseInt(parseInt(ss[1].substring(0,2),16)/2);
    var swg=parseInt(parseInt(ss[1].substring(2,4),16)/2);
    var swb=parseInt(parseInt(ss[1].substring(4,6),16)/2);
    var sideWallColor='#'+((swr<<16)|(swg<<8)|swb).toString(16);
    row++;
    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    var doorColor='#'+ss[1];
    row++;
    ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    var kdoorColor='#'+ss[1];
    var colors=new Colors(ceilColor,floorColor,wallColor,sideWallColor,
      	      	      	  doorColor,kdoorColor);
    row++;
    var lineCount=2*n2+1;
    var wall=[];
    for(j=0;j<lineCount;j++){
      var count=n1+j%2;
      wall[j]=[];
      ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      for(k=0;k<count;k++){
      	wall[j][k]=parseInt(ss[k]);
      }
      row++;
    }
    model.floorIndex[String(label)]=model.floor.length;
    model.floor.push(new Floor(title,label,n1,n2,grid,wall,colors));
  }
  return row;
}

// Cxgf[^ǂݍ
// s - f[^̃Xg
// row - s|C^
function readEventData(s,row){
  var p1,p2,eventp,ev,message;
  model.events.length=0;
  model.elevator.length=0;
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>0){
      var keyWord=ss[0].toLowerCase();
      if(keyWord=='end'){
      	break;
      }
      else if(keyWord=='event'){			// x
      }
      else if(keyWord=='start'){			// X^[g
      	p1=readPointer(1,ss);
      	if(p1!==null){
      	  model.pp=p1;
      	  model.getGrid(p1).throughPoint();
      	  model.getGrid(p1).event=model.events.length;
      	  model.events.push
      	    (new DungeonEvent('',NON_SELECT,ss.slice(4).join(' '),0));
      	}
      }
      else if(keyWord=='goal'){			// S[
      	p1=readPointer(1,ss);
      	if(p1!==null){
      	  model.getGrid(p1).event=model.events.length;
      	  model.events.push
      	    (new DungeonEvent('G',NON_SELECT,ss.slice(4).join(' ')));
      	}
      }
      else if(keyWord=='stairs'){			// Ki
      	p1=readPointer(1,ss);
      	p2=readPointer(4,ss);
      	if((p1!==null) && (p2!==null)){
      	  eventp=model.events.length;
      	  model.getGrid(p1).event=eventp;
      	  model.getGrid(p2).event=eventp+1;
      	  model.events.push
      	    (new DungeonEvent('D',SELECT_2WAY,s[row+1],p2));
      	  model.events.push
      	    (new DungeonEvent('U',SELECT_2WAY,s[row+2],p1));
      	}
      	row+=2;
      }
      else if(keyWord=='warp1way'){			// Г[v
      	p1=readPointer(1,ss);
      	p2=readPointer(4,ss);
      	if((p1!==null) && (p2!==null)){
      	  model.getGrid(p1).event=model.events.length;
      	  model.events.push
      	    (new DungeonEvent('W',NON_SELECT,ss.slice(7).join(' '),p2));
      	}
      }
      else if(keyWord=='warp2way'){			// o[v
      	p1=readPointer(1,ss);
      	p2=readPointer(4,ss);
      	if((p1!==null) && (p2!==null)){
      	  message=ss.slice(7).join(' ');
      	  eventp=model.events.length;
      	  model.getGrid(p1).event=eventp;
      	  model.getGrid(p2).event=eventp+1;
      	  model.events.push
      	    (new DungeonEvent('W',NON_SELECT,message,p2));
      	  model.events.push
      	    (new DungeonEvent('W',NON_SELECT,message,p1));
      	}
      }
      else if(keyWord=='elevator'){			// Gx[^[
      	var floorCount=parseInt(ss[1]);
      	var elevator=new Elevator(floorCount);
      	message=ss.slice(2).join(' ');
      	var ielev=model.elevator.length;
      	for(var i=0;i<floorCount;i++){
      	  row++;
      	  ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
      	  p1=readPointer(0,ss);
      	  if(p1!==null){
      	    eventp=model.events.length;
      	    elevator.setPoint(i,p1,eventp);
      	    model.getGrid(p1).event=eventp;
      	    ev=new DungeonEvent('E',MULTI_SELECT,message);
      	    ev.pointer=ielev;
      	    model.events.push(ev);
      	  }
      	}
      	model.elevator.push(elevator);
      }
      else if(keyWord=='key'){			// 
      	p1=readPointer(2,ss);
      	if(p1!==null){
      	  model.getGrid(p1).event=model.events.length;
      	  ev=new DungeonEvent('',NON_SELECT,s[row+1]);
      	  ev.item=parseInt(ss[1]);
      	  model.events.push(ev);
      	  row++;
      	}
      }
    }
    row++;
  }
  return row;
}

// f[^ǂݍ
// s - f[^̃Xg
// row - s|C^
function readKeyData(s,row){
  clearAss(model.keys);
  clearAss(model.keyIndex);
  while(row<s.length){
    var ss=s[row].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>=3){
      if(ss[0]==='end'){
      	break;
      }
      else if(ss[0]==='key'){
      	var item=ss[1];
      	var label=ss[2];
      	var name=ss.slice(3).join(' ');
      	model.keys[item]=new Key(parseInt(label),name);
      	model.keyIndex[label]=item;
      }
    }
    row++;
  }
  return row;
}

// Kw̃^CgԂ
// label - Kwx
// subTitle - Kw̃Tu^Cg
function getFloorTitle(label,subTitle){
  var s='  ';
  if(label<0){
    s+='B';
  }
  s+=Math.abs(label)+'F';
  if(subTitle.toLowerCase()!=='null'){
    s+='  '+subTitle;
  }
  return s;
}

// 񂪕\ʒu|C^Ԃ
// i0 - JnCfbNX
// ss - z
function readPointer(i0,ss){
  var f=model.floorIndex[ss[i0]];
  if(f===undefined){
    return null;
  }
  else{
    return new Pointer(f,parseInt(ss[i0+1])-1,parseInt(ss[i0+2])-1);
  }
}

// Azz̗vf
// as - Azz
function clearAss(as){
  for(var key in as){
    if(as.hasOwnProperty(key)){
      delete as[key];
    }
  }
}

// `悷
function draw(){
  context.fillStyle=BG_COLOR;
  context.fillRect(0,0,canvas.width,canvas.height);
  drawTitle();
  switch(mapView){
    default:
      draw2DMap();
      break;
    case VIEW_3D:
      draw3DMap();
      break;
  }
  if(waitsw){
    drawMessage();
  }
}

// }bv^Cg`悷
function drawTitle(){
  var floor=model.floor[model.pp.floor],titleBar='';
  if(model.title!=='null'){
    titleBar=model.title;
  }
  if(floor.title!=='null'){
    titleBar+='  '+floor.title;
  }
  titleBar+=DIR_TITLE[model.direc];
  var metrix=context.measureText(titleBar);
  var w=metrix.width+2,h=FONT_SIZE+2,x=parseInt((width-w)/2),y=2;
  context.fillStyle=floor.colors.floor;
  context.fillRect(x,y,w,h);
  context.fillStyle=floor.colors.wall;
  context.fillText(titleBar,x,y);
}

// Qn}`悷
function draw2DMap(){
  var floor=model.floor[model.pp.floor],grid,xx,yy;
  var n1=floor.n1,n2=floor.n2,size=floor.meshSize;
  for(var i=0;i<n1;i++){
    for(var j=0;j<n2;j++){
      grid=floor.grid[i][j];
      if(grid.through){
      	xx=x+size*grid.x;
      	yy=y+size*grid.y;
      	floor.draw2DMesh(xx,yy,model.events,i,j);
      }
    }
  }
  grid=floor.grid[model.pp.x][model.pp.y];
  xx=x+size*grid.x;
  yy=y+size*grid.y;
  floor.drawMe2D(xx,yy,model.direc);
}

// Rn}`悷
function draw3DMap(){
  var floor=model.floor[model.pp.floor],ww=[0,0,0,0];
  d3d.drawBackground(floor.colors);
  for(var i=depth;i>0;i--){
    var jmax=d3d.wallCount[i];
    for(var j=jmax;j>=0;j--){
      var p1=viewPointer(floor,model.pp,model.direc,i-1,-j);
      var p2=viewPointer(floor,model.pp,model.direc,i-1,j);
      switch(model.direc){
      	case NORTH:
      	  ww[0]=floor.northWall(p1.x,p1.y);
      	  ww[1]=floor.northWall(p2.x,p2.y);
      	  ww[2]=floor.westWall(p1.x,p1.y);
      	  ww[3]=floor.eastWall(p2.x,p2.y);
      	  break;
      	case EAST:
      	  ww[0]=floor.eastWall(p1.x,p1.y);
      	  ww[1]=floor.eastWall(p2.x,p2.y);
      	  ww[2]=floor.northWall(p1.x,p1.y);
      	  ww[3]=floor.southWall(p2.x,p2.y);
      	  break;
      	case SOUTH:
      	  ww[0]=floor.southWall(p1.x,p1.y);
      	  ww[1]=floor.southWall(p2.x,p2.y);
      	  ww[2]=floor.eastWall(p1.x,p1.y);
      	  ww[3]=floor.westWall(p2.x,p2.y);
      	  break;
      	case WEST:
      	  ww[0]=floor.westWall(p1.x,p1.y);
      	  ww[1]=floor.westWall(p2.x,p2.y);
      	  ww[2]=floor.southWall(p1.x,p1.y);
      	  ww[3]=floor.northWall(p2.x,p2.y);
      	  break;
      }
      d3d.draw3DMap(i,j,ww);
    }
  }
}

// ΈʒuΈʒu߃|C^Ԃ
// floor - Έʒu߂Kwf[^
// p - Έʒůʒu|C^
// direc - Ăp
// depth - OΈʒu
// side - Έʒu
function viewPointer(floor,p,direc,depth,side){
  var grid=floor.grid[p.x][p.y],px=grid.x,py=grid.y;
  switch(direc){
    case NORTH:			// k
      px+=side;
      py-=depth;
      break;
    case EAST:			// 
      px+=depth;
      py+=side;
      break;
    case SOUTH:			// 
      px-=side;
      py+=depth;
      break;
    case WEST:			// 
      px-=depth;
      py-=side;
      break;
  }
  px=(px+floor.n1)%floor.n1;
  py=(py+floor.n2)%floor.n2;
  return new Pointer(p.floor,px,py);
}

// CxgbZ[W`悷
function drawMessage(){
  if(currentEvent===NO_EVENT) return;
  var e=model.events[currentEvent];
  if(e===null) return;
  model.selectRegion.length=0;
  var metrix=context.measureText(e.message);
  var tw=metrix.width+2,th=FONT_SIZE+2;
  var tx=x+parseInt((width-tw)/2),ty;
  if(e.pointer===undefined){
    ty=y+parseInt((height-th)/2);
  }
  else{			// Gx[^[
    ty=y+2*th;
  }
  drawMessageLine(e.message,tx,ty,tw,th);
  if(e.yn===SELECT_2WAY){
    ty+=th;
    var tyn='Yes / No';
    metrix=context.measureText(tyn);
    tw=metrix.width+2;
    tx=x+parseInt((width-tw)/2);
    var twh=parseInt(0.5*tw);
    drawMessageLine(tyn,tx,ty,tw,th);
    model.selectRegion[0]=new Rectangle(tx,ty,twh,th);
    model.selectRegion[1]=new Rectangle(tx+twh,ty,twh,th);
  }
  else if(e.pointer!==undefined){
    var elev=model.elevator[e.pointer];
    var floors=elev.floorCount,labels=[],i;
    tw=0;
    for(i=0;i<floors;i++){
      var floorIndex=elev.point[i].floor;
      labels[i]=model.floor[floorIndex].getLabelString();
      ty+=th;
      metrix=context.measureText(labels[i]);
      tw=Math.max(tw,metrix.width+2);
      model.selectRegion[i]=new Rectangle(tx,ty,tw,th);
    }
    tx=x+parseInt((width-tw)/2);
    for(i=0;i<floors;i++){
      drawMessageLine(labels[i],tx,model.selectRegion[i].y,tw,th);
      model.selectRegion[i].x=tx;
      model.selectRegion[i].width=tw;
    }
  }
  else{
    model.selectRegion[0]=new Rectangle(tx,ty,tw,th);
  }
}

// CxgbZ[W`悷
// msg - `惁bZ[W
function drawMessageLine(msg,x,y,width,height){
  context.fillStyle=BOARD_COLOR;
  context.fillRect(x,y,width,height);
  context.strokeStyle=TEXT_COLOR;
  context.strokeRect(x,y,width,height);
  context.fillStyle=TEXT_COLOR;
  context.fillText(msg,x,y+1);
}

// OɈړ
function goAhead(){
  if((mapView===VIEW_3D) && !waitsw){
    currentEvent=model.goAhead();
    if(currentEvent!==NO_EVENT){
      waitsw=true;
    }
    draw();
  }
}

// 
function turnLeft(){
  if((mapView===VIEW_3D) && !waitsw){
    model.turn(3);
    draw();
  }
}

// E
function turnRight(){
  if((mapView===VIEW_3D) && !waitsw){
    model.turn(1);
    draw();
  }
}

// 
function turnBack(){
  if((mapView===VIEW_3D) && !waitsw){
    model.turn(2);
    draw();
  }
}

// Yes I
function yesAction(){
  if(waitsw){
    waitsw=false;
    if(currentEvent!==NO_EVENT){
      model.eventAction(currentEvent);
    }
    draw();
  }
}

// No I
function noAction(){
  if(waitsw){
    waitsw=false;
    if(currentEvent!==NO_EVENT){
      var e=model.events[currentEvent];
      if((e!==null) && (e.yn===NON_SELECT)){
      	model.eventAction(currentEvent);
      }
    }
    draw();
  }
}

// Gx[^[̊KwI
// floor - ړKw̃CfbNX
function elevatorAction(floor){
  if(waitsw){
    waitsw=false;
    if(currentEvent!==NO_EVENT){
      model.eventElevator(currentEvent,floor);
    }
    draw();
  }
}

// \ݒ肷
function setView(){
  if(!waitsw){
    mapView=document.getElementById('view').selectedIndex;
    draw();
  }
}

// \ύX
function changeView(){
  if(!waitsw){
    switch(mapView){
      case VIEW_3D:
      	mapView=VIEW_2D;
      	break;
      case VIEW_2D:
      	mapView=VIEW_3D;
      	break;
    }
    document.getElementById('view').selectedIndex=mapView;
    draw();
  }
}

//--------------------------------------------------------------------//
// _Wf[^f
var DungeonDataModel=function(){
  this.title='';		// ^Cg
  this.pp=new Pointer(0,0,0);	// ݂̈ʒu\|C^
  this.direc=NORTH;		// ݌Ăp
  this.floor=[];		// Kwf[^
  this.floorIndex={};		// KwCfbNX
  this.events=[];		// Cxg
  this.elevator=[];		// Gx[^[
  this.keys={};			// 
  this.keyIndex={};		// CfbNX
  this.selectRegion=[];		// CxgI̕\͈
};

// }bv}XڂԂ
// pointer - }Xڂ̈ʒu\|C^
DungeonDataModel.prototype.getGrid=function(pointer){
  return this.getMapGrid(pointer.floor,pointer.x,pointer.y);
};

// }bv}XڂԂ
// floorIndex - KwCfbNX
// x,y - }Xڂ̈ʒu
DungeonDataModel.prototype.getMapGrid=function(floorIndex,x,y){
  return this.floor[floorIndex].grid[x][y];
};

// OɈړ
// Bn_̃CxgCfbNXԂ
DungeonDataModel.prototype.goAhead=function(d){
  var f=this.floor[this.pp.floor],x=this.pp.x,y=this.pp.y;
  var gr=f.grid[x][y],n1=f.n1,n2=f.n2;
  switch(this.direc){
    case NORTH:                    // kɈړ
      if(this.canThrough(f.northWall(x,y))){
      	if(gr.y===0)    this.pp.move(0,n2-1);
      	else            this.pp.move(0,-1);
      }
      break;
    case EAST:                     // Ɉړ
      if(this.canThrough(f.eastWall(x,y))){
      	if(gr.x===n1-1) this.pp.move(-n1+1,0);
      	else            this.pp.move(1,0);
      }
      break;
    case SOUTH:                    // Ɉړ
      if(this.canThrough(f.southWall(x,y))){
      	if(gr.y===n2-1) this.pp.move(0,-n2+1);
      	else            this.pp.move(0,1);
      }
      break;
    case WEST:                     // Ɉړ
      if(this.canThrough(f.westWall(x,y))){
      	if(gr.x===0)    this.pp.move(n1-1,0);
      	else            this.pp.move(-1,0);
      }
      break;
  }
  gr=this.getGrid(this.pp);
  gr.throughPoint();
  return gr.event;
};

// ς
// d - 1:E,2:,3:
DungeonDataModel.prototype.turn=function(d){
  this.direc=(this.direc+d)%4;
};

// ʉ߉\ǂ肷
// wall - Ώۂ̕ǃf[^
DungeonDataModel.prototype.canThrough=function(wall){
  if(wall===WALL){
    return false;
  }
  else if(wall<0){
    var index=this.keyIndex[String(wall)];
    if(index!==undefined) return this.keys[index].get;
  }
  return true;
};

// Cxgs
// ev - Cxg̃CfbNX
// mx,my - }EXʒux,yW
DungeonDataModel.prototype.eventSelect=function(ev,mx,my){
  var e=this.events[ev];
  if(e===null){
    return 0;
  }
  else if(e.yn===NON_SELECT){
    if(this.selectRegion[0].contains(mx,my)) return 1;
  }
  else if(e.yn===SELECT_2WAY){
    if(this.selectRegion[0].contains(mx,my))      return 1;
    else if(this.selectRegion[1].contains(mx,my)) return 0;
  }
  else if(e.pointer!==undefined){
    for(var i=0;i<this.selectRegion.length;i++){
      if(this.selectRegion[i].contains(mx,my)) return i+2;
    }
  }
  return 0;
};

// Cxgs
// ev - Cxg̃CfbNX
DungeonDataModel.prototype.eventAction=function(ev){
// Jnn_
  if(this.events[ev]===null) return;
  if(this.events[ev].move===0){
    this.events[ev]=null;
    this.getGrid(this.pp).event=NO_EVENT;
  }
// ړCxg (KiEKiEГ[vEo[v)
  else if(this.events[ev].move!==undefined){
    this.pp=this.events[ev].move.clone();
    this.getGrid(this.pp).throughPoint();
  }
// l
  else if(this.events[ev].item!==undefined){
    var index=this.events[ev].item;
    this.keys[String(index)].getKey();
    this.events[ev]=null;
    this.getGrid(this.pp).event=NO_EVENT;
  }
};

// Cxgs
// ev - Cxg̃CfbNX
// floor - ړKw̃CfbNX
DungeonDataModel.prototype.eventElevator=function(ev,floor){
  if(this.events[ev].pointer!==undefined){
    var elev=this.elevator[this.events[ev].pointer];
    this.pp=elev.point[floor].clone();
    this.getGrid(this.pp).throughPoint();
  }
};

//--------------------------------------------------------------------//
// ʒu|C^
// floor - KwCfbNX
// x,y - Kw̒̈ʒu
var Pointer=function(floor,x,y){
  this.floor=floor;
  this.x=x;
  this.y=y;
};

// |C^ړ
// dx,dy - ړ
Pointer.prototype.move=function(dx,dy){
  this.x+=dx;
  this.y+=dy;
};

// |C^̃Rs[Ԃ
Pointer.prototype.clone=function(){
  return new this.constructor(this.floor,this.x,this.y);
};

//--------------------------------------------------------------------//
// Kwf[^
// title - Kw^Cg
// floor - Kwx
// n1,n2 - Ec̃}Xڂ̐
// grid - }bv}Xڃf[^z
// wall - ǃf[^z
// colors - Kw\Ff[^
var Floor=function(title,floor,n1,n2,grid,wall,colors){
  this.title=title;
  this.floor=floor;
  this.n1=n1;
  this.n2=n2;
  this.grid=grid;
  this.wall=wall;
  this.colors=colors;
// }Xڂ2D\TCY
  this.meshSize=parseInt(Math.min(width/n1,height/n2));
};

// KwxԂ
Floor.prototype.getLabelString=function(x,y){
  if(this.floor<0){
    return 'B'+Math.abs(this.floor)+'F';
  }
  else{
    return this.floor+'F';
  }
};

// k̕ǃf[^Ԃ
// x,y - }Xڂ̈ʒu
Floor.prototype.northWall=function(x,y){
  var p=this.grid[x][y].northWall;
  return this.wall[p.x][p.y];
};

// 쑤̕ǃf[^Ԃ
// x,y - }Xڂ̈ʒu
Floor.prototype.southWall=function(x,y){
  var p=this.grid[x][y].southWall;
  return this.wall[p.x][p.y];
};

// ̕ǃf[^Ԃ
// x,y - }Xڂ̈ʒu
Floor.prototype.eastWall=function(x,y){
  var p=this.grid[x][y].eastWall;
  return this.wall[p.x][p.y];
};

// ̕ǃf[^Ԃ
// x,y - }Xڂ̈ʒu
Floor.prototype.westWall=function(x,y){
  var p=this.grid[x][y].westWall;
  return this.wall[p.x][p.y];
};

// Qn}̃}Xڂ\
// x,y - }Xڕ\ʒu
// events - Cxg̃Xg
// px,py - Kwʒũ|C^
Floor.prototype.draw2DMesh=function(x,y,events,px,py){
  context.fillStyle=this.colors.floor;
  context.fillRect(x,y,this.meshSize,this.meshSize);
  var size=this.meshSize;
  drawWall2D(x,y,x+size,y,this.northWall(px,py),this.colors);
  drawWall2D(x,y,x,y+size,this.westWall(px,py),this.colors);
  drawWall2D(x+size,y,x+size,y+size,this.eastWall(px,py),this.colors);
  drawWall2D(x,y+size,x+size,y+size,this.southWall(px,py),this.colors);
  var ev=this.grid[px][py].event;
  if((ev!==NO_EVENT) && (events[ev]!==null)){
    context.fillStyle=this.colors.wall;
    var metrix=context.measureText(events[ev].mark);
    var dx=parseInt((size-metrix.width)/2);
    var dy=parseInt((size-FONT_SIZE)/2);
    context.fillText(events[ev].mark,x+dx,y+dy);
  }
};

// Qn}̎ʒu\
// x,y - }Xڕ\ʒu
// direc - Ăp
Floor.prototype.drawMe2D=function(x,y,direc){
  var size=this.meshSize;
  var q1=parseInt(0.25*size),q2=parseInt(0.5*size),q3=size-q1;
  switch(direc){
    case NORTH:              // k
      fillPolygon([x+q2,x+q1,x+q3],[y+q1,y+q3,y+q3],3,
      	      	  this.colors.door);
      break;
    case EAST:               // 
      fillPolygon([x+q3,x+q1,x+q1],[y+q2,y+q1,y+q3],3,
      	      	  this.colors.door);
      break;
    case SOUTH:              // 
      fillPolygon([x+q2,x+q1,x+q3],[y+q3,y+q1,y+q1],3,
      	      	  this.colors.door);
      break;
    case WEST:               // 
      fillPolygon([x+q1,x+q3,x+q3],[y+q2,y+q1,y+q3],3,
      	      	  this.colors.door);
      break;
  }
};

// ǂ\
// x1,y1,x2,y2 - n_,I_x,yW
// wall - ǃf[^
// colors - Kw\F
function drawWall2D(x1,y1,x2,y2,wall,colors){
  var sx,sy;
  if(wall===WALL){
    drawLine(x1,y1,x2,y2,colors.wall);
  }
  else if(wall===DOOR){
    drawLine(x1,y1,x2,y2,colors.wall);
    sx=parseInt(0.25*(x2-x1));
    sy=parseInt(0.25*(y2-y1));
    drawLine(x1+sx,y1+sy,x2-sx,y2-sy,colors.door);
  }
  else if(wall<0){
    drawLine(x1,y1,x2,y2,colors.wall);
    sx=parseInt(0.25*(x2-x1));
    sy=parseInt(0.25*(y2-y1));
    drawLine(x1+sx,y1+sy,x2-sx,y2-sy,colors.keyDoor);
  }
}
// `悷
// x1,y1,x2,y2 - n_,I_x,yW
// color - F
function drawLine(x1,y1,x2,y2,color){
  context.strokeStyle=color;
  context.beginPath();
  context.moveTo(x1,y1);
  context.lineTo(x2,y2);
  context.closePath();
  context.stroke();
}

//--------------------------------------------------------------------//
// Kw\Ff[^
// ceil - V\F
// floor - \F
// wall - Ǖ\F
// sideWall -  () \F
// door - \F
// keyDoor - t\F
var Colors=function(ceil,floor,wall,sideWall,door,keyDoor){
  this.ceil=ceil;
  this.floor=floor;
  this.wall=wall;
  this.sideWall=sideWall;
  this.door=door;
  this.keyDoor=keyDoor;
};

//--------------------------------------------------------------------//
// }bv}Xڃf[^
// x,y - }Xڂx,yW
var MapGrid=function(x,y){
  this.x=x;
  this.y=y;
  this.through=false;
  this.event=NO_EVENT;
// ǃ|C^̓}Xڂɑ΂x,yt
  this.northWall={x:2*y,y:x};
  this.southWall={x:2*y+2,y:x};
  this.eastWall={x:2*y+1,y:x+1};
  this.westWall={x:2*y+1,y:x};
};

// |Cgʉ߂
MapGrid.prototype.throughPoint=function(){
  this.through=true;
};

//--------------------------------------------------------------------//
// Cxg
// mark - 
// yn - Yes/No IvV
// message - CxgbZ[W
// move - ړ̃|C^
var DungeonEvent=function(mark,yn,message,move){
  this.mark=mark;
  this.yn=yn;
  this.message=message;
  this.move=move;
};

//--------------------------------------------------------------------//
// Gx[^[
// floorCount - ړłtA
var Elevator=function(floorCount){
  this.floorCount=floorCount;
  this.point=[];	// Gx[^[ʒu
  this.event=[];	// Gx[^[̃CxgCfbNX
};

// Kwf[^ݒ肷
// floor - Kw̃CfbNX
// pt - ݒ肷Gx[^ʒũ|C^
// ev - ݒ肷Gx[^[̃CxgCfbNX
Elevator.prototype.setPoint=function(floor,pt,ev){
  this.point[floor]=pt;
  this.event[floor]=ev;
};

//--------------------------------------------------------------------//
// 
// label - x
// name - ̖O
var Key=function(label,name){
  this.label=label;
  this.name=name;
  this.get=false;	// lĂȂ
};

// l
Key.prototype.getKey=function(){
  this.get=true;
};

//--------------------------------------------------------------------//
// R}bv\[eBeB
var Draw3D=function(){
  this.rect=[];		// \`̍W
  this.wallCount=[];	// \ΏۂƂȂǂ̐
  this.wallX=[0,0,0,0];	// Ǖ\`̍W
  this.wallY=[0,0,0,0];
  this.doorX=[0,0,0,0];	// \`̍W
  this.doorY=[0,0,0,0];
  this.rect[0]=new Rectangle(0,0,width,height);
  this.wallCount[0]=0;
  var xi=parseInt(width/10),yi=parseInt(height/10);
  this.rect[1]=new Rectangle(xi,yi,width-2*xi,height-2*yi);
  this.wallCount[1]=1;
  for(var i=2;i<=depth+1;i++){
    xi+=parseInt((width-2*xi)/6);
    yi+=parseInt((height-2*yi)/6);
    this.rect[i]=new Rectangle(xi,yi,width-2*xi,height-2*yi);
    this.wallCount[i]=parseInt((width/this.rect[i].width+1)/2);
  }
};

// Rn}̔wi`悷
// colors - Kw\Ff[^
Draw3D.prototype.drawBackground=function(colors){
  this.colors=colors;
  context.fillStyle=colors.ceil;
  context.fillRect(x,y,width,this.rect[depth].y);
  context.fillStyle=BG_COLOR;
  context.fillRect(x,y+this.rect[depth].y,
      	      	   width,this.rect[depth].height);
  context.fillStyle=colors.floor;
  context.fillRect(x,y+height-this.rect[depth].y,
      	      	   width,this.rect[depth].y);
};

// Rn}̃}Xڂ\
// depth - OΈʒu
// side - Έʒu
// ww - ǃf[^
Draw3D.prototype.draw3DMap=function(depth,side,ww){
  var xx=[this.rect[depth].x-this.rect[depth].width*side,
      	  this.rect[depth].x+this.rect[depth].width*side];
  var wallWidth=this.rect[depth].width;
  if(xx[0]<0){
    wallWidth+=xx[0];
    xx[0]=0;
    xx[1]=width-wallWidth;
  }
  var i;
  for(i=0;i<2;i++){
    var fwall=new Rectangle(x+xx[i],y+this.rect[depth].y,
      	      	      	    wallWidth,this.rect[depth].height);
    if(ww[i]==WALL){
      this.drawFrontWall(fwall,this.colors.wall);
    }
    else if(ww[i]==DOOR){
      this.drawFrontWall(fwall,this.colors.wall);
      this.drawFrontDoor(xx[i],this.rect[depth],side,this.colors.door);
    }
    else if(ww[i]<0){
      this.drawFrontWall(fwall,this.colors.wall);
      this.drawFrontDoor(xx[i],this.rect[depth],side,this.colors.keyDoor);
    }
  }
  if((side!=this.wallCount[depth]) && (side<=this.wallCount[depth-1])){
    xx[0]=-side;
    xx[1]=1+side;
    for(i=0;i<2;i++){
      if(ww[i+2]==WALL){
      	this.drawSideWall(depth,xx[i],this.colors.sideWall);
      }
      else if(ww[i+2]==DOOR){
      	this.drawSideWall(depth,xx[i],this.colors.sideWall);
      	this.drawSideDoor(depth-1,xx[i],this.colors.door);
      }
      else if(ww[i+2]<0){
      	this.drawSideWall(depth,xx[i],this.colors.sideWall);
      	this.drawSideDoor(depth-1,xx[i],this.colors.keyDoor);
      }
    }
  }
};

// O̕ǂ`悷
// wall - ǌ`
// color - ǖʐF
Draw3D.prototype.drawFrontWall=function(wall,color){
  context.fillStyle=color;
  context.fillRect(wall.x,wall.y,wall.width,wall.height);
  context.strokeStyle=this.colors.floor;
  context.strokeRect(wall.x,wall.y,wall.width,wall.height);
};

// O̔`悷
// gridX - }Xڂ̕\ʒuxW
// rect - \͈
// side - Έʒu
// color - \F
Draw3D.prototype.drawFrontDoor=function(gridX,rect,side,color){
  var doorX=parseInt(0.25*rect.width),doorY=parseInt(0.2*rect.height);
  var doorWidth=rect.width-2*doorX;
  if(gridX===0){
    doorX+=rect.x-rect.width*side;
    if(doorX<0){
      doorWidth+=doorX;
      doorX=0;
    }
  }
  doorWidth=Math.min(doorWidth,width-gridX-doorX);
  if(doorWidth>0){
    var door=new Rectangle(x+gridX+doorX,y+rect.y+doorY,
      	      	      	   doorWidth,rect.height-doorY);
    this.drawFrontWall(door,color);
  }
};

// Ǖ\`쐬
// depth - OΈʒu
// side - Έʒu
// color - \F
Draw3D.prototype.drawSideWall=function(depth,side,color){
  var xmax=x+width,r1=this.rect[depth-1],r2=this.rect[depth],dwy;
  this.wallY[0]=y+r1.y;
  this.wallY[1]=y+r2.y;
  this.wallY[2]=this.wallY[1]+r2.height;
  this.wallY[3]=this.wallY[0]+r1.height;
  this.wallX[0]=x+r1.x+r1.width*side;
  this.wallX[1]=x+r2.x+r2.width*side;
  if(this.wallX[0]<x){
    dwy=(this.wallY[1]-this.wallY[0])*(x-this.wallX[0])
       /(this.wallX[1]-this.wallX[0]);
    this.wallY[0]+=dwy;
    this.wallY[3]-=dwy;
    this.wallX[0]=x;
  }
  else if(this.wallX[0]>xmax){
    dwy=(this.wallY[1]-this.wallY[0])*(xmax-this.wallX[0])
       /(this.wallX[1]-this.wallX[0]);
    this.wallY[0]+=dwy;
    this.wallY[3]-=dwy;
    this.wallX[0]=xmax;
  }
  this.wallX[2]=this.wallX[1];
  this.wallX[3]=this.wallX[0];
  fillPolygon(this.wallX,this.wallY,4,color);
};

// \`쐬
// depth - OΈʒu
// side - Έʒu
// color - \F
Draw3D.prototype.drawSideDoor=function(depth,side,color){
  var xmax=x+width,r1=this.rect[depth];
  this.wallX[0]=x+r1.x+r1.width*side;
  this.wallY[0]=y+r1.y;
  this.wallY[3]=this.wallY[0]+r1.height;
  if(depth===0){
    this.doorX[0]=this.wallX[0];
    this.doorX[1]=parseInt(0.5*(this.wallX[0]+this.wallX[1]));
    this.doorY[0]=this.wallY[0];
    this.doorY[1]=parseInt(0.5*(this.wallY[0]+this.wallY[1]));
    this.doorY[2]=parseInt(0.5*(this.wallY[3]+this.wallY[2]));
    this.doorY[3]=this.wallY[3];
  }
  else{
    this.doorX[0]=parseInt(0.25*(3*this.wallX[0]+this.wallX[1]));
    this.doorX[1]=parseInt(0.25*(this.wallX[0]+3*this.wallX[1]));
    this.doorY[0]=parseInt(0.25*(3*this.wallY[0]+this.wallY[1]));
    this.doorY[1]=parseInt(0.25*(this.wallY[0]+3*this.wallY[1]));
    this.doorY[2]=parseInt(0.25*(this.wallY[3]+3*this.wallY[2]));
    this.doorY[3]=parseInt(0.25*(3*this.wallY[3]+this.wallY[2]));
  }
  this.doorY[0]+=parseInt(0.2*(this.doorY[3]-this.doorY[0]));
  this.doorY[1]+=parseInt(0.2*(this.doorY[2]-this.doorY[1]));
  var doorWidth=this.doorX[1]-this.doorX[0];
  if(this.doorX[0]<x){
    this.doorY[0]+=parseInt((this.doorY[1]-this.doorY[0])
      	      	      	   *(x-this.doorX[0])/doorWidth);
    this.doorY[3]+=parseInt((this.doorY[2]-this.doorY[3])
      	      	      	   *(x-this.doorX[0])/doorWidth);
    this.doorX[0]=x;
  }
  else if(this.doorX[0]>xmax){
    this.doorY[0]+=parseInt((this.doorY[1]-this.doorY[0])
      	      	      	   *(xmax-this.doorX[0])/doorWidth);
    this.doorY[3]+=parseInt((this.doorY[2]-this.doorY[3])
      	      	      	   *(xmax-this.doorX[0])/doorWidth);
    this.doorX[0]=xmax;
  }
  this.doorX[2]=this.doorX[1];
  this.doorX[3]=this.doorX[0];
  fillPolygon(this.doorX,this.doorY,4,color);
};

// p``悷
// x,y - `x,yW
// color - hԂF
function fillPolygon(x,y,count,color){
  context.fillStyle=color;
  context.beginPath();
  context.moveTo(x[0],y[0]);
  for(var i=1;i<count;i++) context.lineTo(x[i],y[i]);
  context.closePath();
  context.fill();
}

//--------------------------------------------------------------------//
// lp`
// x,y,width,height - x,yW,,
var Rectangle=function(x,y,width,height){
  this.x=x;
  this.y=y;
  this.width=width;
  this.height=height;
};

// _ɂꍇ true
// px,py - _̍W
Rectangle.prototype.contains=function(px,py){
  return ((this.x<=px) && (px<=this.x+this.width)
       && (this.y<=py) && (py<=this.y+this.height));
};
